function mixmat = ConsSrc(chip,avsrc)

% SonsSrc -   mixing matrix from consensus sources
%
%  usage:    mixmat = ConsSrc(chip,avsrc)
%
%
% INPUT VARIABLES
% ---------------
% chip:        (float array): ngenes X ncond
%                   contains expression data
%
% avsrc:       (float array): nsources X ngenes
%                   contains expression data

StiffMat = avsrc * avsrc'; % stiffness matrix from the average sources
iStiffMat = inv(StiffMat);

chip=chip';
chip = chip -mean(chip')'*ones(1,size(chip,2));
chip=chip';
ScProd = avsrc*chip;
mixmat = iStiffMat*ScProd;
mixmat = mixmat';
