function [avsrc,counter] = GatherSrc(src, thresh, maxsrcnb)

nbsimul = size(src);
nbsimul = nbsimul(2);

allsrc = [];
h = waitbar(0,'Gather sources');
for simul=1:nbsimul,
  allsrc = [allsrc;src{simul}];
  waitbar(simul/nbsimul,h);
end;
close(h);

tmp = corrcoef(allsrc');
SgnMat = sign(tmp);
tmp = tmp .* tmp;
IncMat =  (tmp > thresh);
SgnMat = SgnMat .* IncMat;
clear tmp;

% Estimate average sources
avsrc = [];

% initialisation
LocMat = IncMat;
LocSrc = allsrc;
LocSgn = SgnMat;

counter = zeros(maxsrcnb,1);
% main loop
h = waitbar(0,'Search consensus sources');
for k = 1:maxsrcnb,
  [nb,pos] = max(sum(LocMat));
  counter(k) = nb;
  selsrcpos = find(LocMat(pos,:));
  othsrcpos = find(~LocMat(pos,:));
  tmpsrc = LocSgn(pos,selsrcpos)*LocSrc(selsrcpos,:)/nb;  %  a verifier
  avsrc = [avsrc;tmpsrc];
  LocMat = LocMat(othsrcpos,othsrcpos);
  LocSgn = LocSgn(othsrcpos,othsrcpos);
  LocSrc = LocSrc(othsrcpos,:);
  waitbar(k/maxsrcnb,h);
end;
close(h);

% Display results
%fprintf('Results:\n');
for k=1:maxsrcnb,
    sigchar{k} = ['Source ',num2str(k),':  ',num2str(counter(k)/nbsimul*100),'%'];
%  fprintf('  Source %d: %f\n',k,counter(k)/nbsimul);
end;
msgbox(sigchar,'Credibilities','none');

