function GenSSReport(avsrc, gene, classnum, GenSSData, counter, fileid)

red = GenSSData{1};
initsrcnb = GenSSData{2};
app = GenSSData{3};
NL = GenSSData{4};
stab = GenSSData{5};
nbsimul = GenSSData{6};
thresh = GenSSData{7};
pval = GenSSData{8};
% fileid = GenSSData{9};
sort = GenSSData{10};

srcnb = size(avsrc); srcnb = srcnb(1);

% Estimate significant genes for each source
mval = erfinv(1-pval);

% Report results
% ---------------
h = waitbar(0,'Save results to file');
outfile = fopen(fileid,'w');
fprintf(outfile,'\n');
fprintf(outfile,['MarraySS                             ',datestr(now,31),'\n']);
fprintf(outfile,'%s\n','%%%%%%%%');
fprintf(outfile,'\n');
fprintf(outfile,'Source Separation and consensus sources search\n');
fprintf(outfile,'***********************************************\n\n\n');
fprintf(outfile,'Parameters:\n');
fprintf(outfile,'----------:\n');
fprintf(outfile,'Reduced dimension: %d \n',red);
fprintf(outfile,'Initial number of sources: %d \n',initsrcnb);
fprintf(outfile,'Non-linearity: %s \n',NL);
fprintf(outfile,'Approach: %s \n',app);
fprintf(outfile,'Stabilization: %s \n',stab);
fprintf(outfile,'p-value: %d \n',pval);
fprintf(outfile,'Threshold for selecting consensus sources: %d \n',thresh);
fprintf(outfile,'Number of retained consensus sources: %d \n',srcnb);
fprintf(outfile,'\n\n\n\n');



for k=1:srcnb,
  waitbar(k/srcnb,h);
  fprintf(outfile,'Source %d (credibility: %f percent):\n',k,100*counter(k)/nbsimul);
  fprintf(outfile,'----------\n',k);

  fprintf(outfile,'subclass -:\n');,
%  tmp2=avsrc(k,:);,
%  tmp2=tmp2-mean(tmp2);
%  [a,b]=sort(tmp2);,
%  a=a'; b=b';,
  kk=2*k-1;
%  ll(kk) = length(find(a<=-mval*std(tmp2)));,
%  classnum{kk,1} = ll(kk);
% classnum{kk,2} = b(1:ll(kk));
% classnum{kk,3}=gene(b(1:ll(kk)));
%  classnum{kk,4}=a(1:ll(kk));
  ll(kk) = classnum{kk,1};
  b(1:ll(kk)) = classnum{kk,2};
%  classnum{kk,3} = gene(b(1:ll(kk)));
  a(1:ll(kk)) = classnum{kk,4};
 for l=1:ll(kk),
    tmp=strcat(':  ',num2str(a(l)));
    cl{kk,l} = strcat(gene{b(l)},tmp);,
    fprintf(outfile,'  %s (%d): %f\n',gene{b(l)},b(l),a(l));,
  end;,

  fprintf(outfile,'\n');
  fprintf(outfile,'subclass +:\n');
%  [a,b]=sort(-tmp2);,
%  a=a'; b=b';,
  kk=2*k;
%  ll(kk) = length(find(a<=-mval*std(tmp2)));,
%  classnum{kk,1} = ll(kk);
%  classnum{kk,2} = b(1:ll(kk));
%  classnum{kk,3}=gene(b(1:ll(kk)));
%  classnum{kk,4}=-a(1:ll(kk));
  ll(kk) = classnum{kk,1};
  b(1:ll(kk)) = classnum{kk,2};
%  classnum{kk,3}=gene(b(1:ll(kk)));
  a(1:ll(kk)) = - classnum{kk,4};
 for l=1:ll(kk),
    tmp=strcat(':  ',num2str(-a(l)));
    cl{kk,l} = strcat(gene{b(l)},tmp);,
    fprintf(outfile,'  %s (%d): %f\n',gene{b(l)},b(l),a(l));
  end;,
   fprintf(outfile,'----------------------------------------------\n\n');
end;

if strcmp(sort,'on'),
  fprintf(outfile,'***********************************************\n\n');
  fprintf(outfile,'SORTED CLASSES\n\n\n\n\n');

  for k=1:srcnb,
    fprintf(outfile,'Source %d:\n',k);
    fprintf(outfile,'----------\n',k);

    fprintf(outfile,'subclass -:\n');,
    kk=2*k-1;
    u=char(cl{kk,1:ll(kk)});
    u=sortrows(u);
    for l=1:ll(kk),
      fprintf(outfile,'  %s\n',u(l,:));,
    end;,
    fprintf(outfile,'\n');,

    fprintf(outfile,'subclass +:\n');,
    kk=2*k;
    u=char(cl{kk,1:ll(kk)});
    u=sortrows(u);
    for l=1:ll(kk),
      fprintf(outfile,'  %s\n',u(l,:));,
    end;,
    fprintf(outfile,'\n');,

  end;
end;
fclose(outfile);
close(h);  

%fprintf(strcat('Report succesfully written to file: ',fileid));
msgbox(strcat('Report succesfully written to file: ',fileid),'MarraySS');

