function I = MImat(pop)

% MImat -   row-wise mutual information
%
%  usage:    I = MImat(pop)
%
%
% INPUT VARIABLES
% ---------------
% pop:    (2D array): data array
%                   
%
%
% OUTPUT VARIABLES
% ----------------
% I:           (float array): nrow X nrow
%                   contains row-wise mutual information

dimensions = size(pop);
nrow = dimensions(1);
ncol = dimensions(2);

I = zeros(nrow,nrow);

for elem1=1:nrow
  for elem2=1:(elem1-1)
     I(elem1,elem2) = mutinf(pop(elem1,:),pop(elem2,:));
  end;
end;

tmp = reshape(I,nrow*nrow,1);
tmp = tmp(find(tmp));
tmp=-sort(-tmp);
ltmp = length(tmp);

i1=floor(.9 * ltmp); c1 = tmp(i1);
i2=floor(.99 * ltmp); c2 = tmp(i2);
i3=floor(.999 * ltmp); c3 = tmp(i3);
i4=floor(.9999 * ltmp); c4 = tmp(i4);

fprintf('Critical values: 10 percent: %e; 1 percent: %e; .1 percent: %e; .01 percent: %e',c1,c2,c3,c4);


