function [avsrc,mixmat] = SrcComp(chip,src,thresh)

nbsimul = size(src); nbsimul = nbsimul(2);
srcnb = size(src{1}); ngenes = srcnb(2); srcnb = srcnb(1);
numbers = 1:srcnb;
numbers = numbers';

h = waitbar(0,'Compare different estimations');
for sim1=1:nbsimul,
  waitbar(sim1/nbsimul,h);
  Positions{sim1,sim1} = diag(ones(srcnb,1));
  tmp1 = src{sim1};
%  for sim2=1:nbsimul,
  for sim2=1:(sim1-1),
    tmp2 = src{sim2};
    scprod = tmp1 * tmp2';
    % the (k,l) element of scprod contains scalar product of k-th
    % source of sim 1 with l-th source of  sim2
    tmp = abs(scprod);
    CoincMat = (tmp>thresh).*sign(scprod);
    Positions{sim1,sim2} = CoincMat*numbers;
    CoincMat = (tmp'>thresh).*sign(scprod');
    Positions{sim2,sim1} = CoincMat*numbers;
  end;
end;
close(h);

h = waitbar(0,'Average source 1');
sim1=1;
src1 = src{sim1};

avsrc = zeros(srcnb,ngenes);
counter = zeros(srcnb,1);

for k = 1:srcnb,
  waitbar(k/srcnb,h);
  for sim2=1:nbsimul,
    tmp = Positions{sim1,sim2};
    pos = tmp(k);
    src2 = src{sim2};
    if pos ~= 0,
      avsrc(k,:) = avsrc(k,:) + sign(pos)*src2(abs(pos),:);
      counter(k) = counter(k)+1;
    end;
  end;
  avsrc(k,:) = avsrc(k,:)/counter(k);
end;
close(h);

% Sorting by credibility
[s p] = sort(-counter);
counter = -s;
avsrc = avsrc(p,:);

fprintf('Results:\n');
for k=1:srcnb,
  fprintf('  Source %d: %f\n',k,counter(k)/nbsimul);
end;

% Estimate average mixing matrix
mixmat = ConsSrc(chip,avsrc);
figure; discr(mixmat,srcnb);

