function [chip,gene,cond] = chipload(filename);

% chipload -   Source Separation for expression data
%            (based upon FastICA, by Hyvrinen et al)
%
%  usage:    [chip,gene,cond] = chipload(filename);
%
%
% INPUT VARIABLES
% ---------------
% filename:    (string): input filename
%                   
%
%
% OUTPUT VARIABLES
% ----------------
% chip:        (float array): ngenes X ncond
%                   contains expression data
% gene:        (char array): column vector of size ngenes
%                   contains gene names
% cond:        (char array): line vector of size ncond
%                   contains condition names

x=importdata(filename);
chip = x.data;
[ngene ncond]=size(chip);
gene = x.textdata(2:(ngene+1),1);
cond = x.textdata(1,2:(ncond+1));

