function [] = finfoclass(fileid,classnum,mixmat,cond,n,nclass)

% infoclass - display results from genSS
%
%  usage:    infoclass(classnum,mixmat,cond,n)
%
%
% INPUT VARIABLES
% ---------------
% classnum:    (cell array)
%                   class numbers (output of genSS)
% mixmat:      (float array): ncond X srcnb
%                   mixing matrix (output of genSS)
% cond:        (cell array): ncond 
%                   names of conditions
% n:           (integer)
%                   component number
%%%%

ncond = size(cond); ncond=ncond(2);

fp = fopen(fileid,'w');
plotdens(mixmat(:,n),std(mixmat(:,n)/5));

fprintf(fp,'\n');
fprintf(fp,['MarraySS                             ',datestr(now,31),'\n']);
fprintf(fp,'%s\n','%%%%%%%%');
fprintf(fp,'\n');
fprintf(fp,'Informations on source %d\n',n);
fprintf(fp,'**************************\n\n',n);
[a b]=sort(mixmat(:,n));
fprintf(fp,'sorted coefficients:\n');
fprintf(fp,'********************\n\n');
for k=1:ncond,
  fprintf(fp,'%s\n',[num2str(b(k)),'  ',num2str(a(k)),'       ', cond{b(k)}]);
end;
%disp([b a])
fprintf(fp,'\n');
fprintf(fp,'\n');
fprintf(fp,'\n');

fprintf(fp,'sorted genes:\n');
fprintf(fp,'*************\n\n');
fprintf(fp,'\n');
fprintf(fp,'Significant genes (negative):\n');
fprintf(fp,'-----------------------------\n\n');

for cl=1:classnum{2*n-1,1}
    fprintf(fp,'%s\n',classnum{2*n-1,3}{cl});
end
fprintf(fp,'\n\n');
fprintf(fp,'Significant genes (positive):\n');
fprintf(fp,'-----------------------------\n\n');
for cl=1:classnum{2*n,1}
    fprintf(fp,'%s\n',classnum{2*n,3}{cl});
end

fclose(fp);
