function [] = infoclass(classnum,mixmat,cond,n,nclass)

% infoclass - display results from genSS
%
%  usage:    infoclass(classnum,mixmat,cond,n)
%
%
% INPUT VARIABLES
% ---------------
% classnum:    (cell array)
%                   class numbers (output of genSS)
% mixmat:      (float array): ncond X srcnb
%                   mixing matrix (output of genSS)
% cond:        (cell array): ncond 
%                   names of conditions
% n:           (integer)
%                   component number
%%%%

ncond = size(cond);ncond=ncond(2);

fprintf('\n');
fprintf('Informations on independent component %d\n',n);
fprintf('----------------------------------------\n\n',n);
[a b]=sort(mixmat(:,n));
fprintf('sorted coefficients:\n');
fprintf('--------------------\n');
for k=1:ncond,
  disp([num2str(b(k)),'  ',num2str(a(k)),'       ', cond{b(k)}]);
end;
%disp([b a])
fprintf('\n');
fprintf('\n');
fprintf('\n');
%hist(mixmat(:,n),nclass);
plotdens(mixmat(:,n),std(mixmat(:,n)/5));
title(strcat('Source ',num2str(n)));
fprintf('Significant genes (negative):\n');
fprintf('-----------------------------\n');
disp(strcat(classnum{2*n-1,3},...
   strcat(strcat(' (',num2str(classnum{2*n-1,2})),')')));
fprintf('Significant genes (positive):\n');
fprintf('-----------------------------\n');
disp(strcat(classnum{2*n,3},...
   strcat(strcat(' (',num2str(classnum{2*n,2})),')')));
