function [globsrc,globcounter] = syscomp(src,counter,thresh)
%
% syscomp: systematic comparison of sources
%
%  syntax: [globsrc,globcounter] = syscomp(src,counter)
%

tmp = size(src);
ngene=tmp(2);
nsrc=tmp(1);


scprod = src * src';
tmp = abs(scprod)>thresh;
sgn = sign(scprod);

mark = zeros(nsrc,1);

globsrc = zeros(nsrc,ngene);
globcounter = zeros(nsrc);

k=0;
h = waitbar(0,'Supersources');
for i=1:nsrc,
  waitbar(i/nsrc,h);
  if mark(i)~=1,
    k=k+1;
    globsrc(k,:) = counter(i)*src(i,:);
    globcounter(k) = counter(i);
    for j=(i+1):nsrc,
      if ((mark(j)~=1)&(tmp(i,j)==1)),
	globsrc(k,:) = globsrc(k,:) + sgn(i,j)*counter(j)*src(j,:);
	globcounter(k) = globcounter(k) + counter(j);
	mark(j)=1;
      end;
    end;
  end;
end;
close(h);

fprintf('%d sources found\n',k);

globsrc = globsrc(1:k,:);
globcounter = globcounter(1:k);

for l=1:k,
  globsrc(l,:) = globsrc(l,:)/globcounter(l); 
end;



